'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _reactBootstrap = require('react-bootstrap');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Navigation = function (_Component) {
  _inherits(Navigation, _Component);

  function Navigation() {
    _classCallCheck(this, Navigation);

    return _possibleConstructorReturn(this, (Navigation.__proto__ || Object.getPrototypeOf(Navigation)).apply(this, arguments));
  }

  _createClass(Navigation, [{
    key: 'renderLayout',
    value: function renderLayout(obj) {
      var _this2 = this;

      var menuItem = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var pathname = this.props.location.pathname;

      if (obj.hasOwnProperty('link')) {
        var props = {
          active: pathname === obj.link,
          key: obj.link,
          href: '#',
          onClick: function onClick(e) {
            e.preventDefault();
            if (_this2.props.target || e.button !== 0) return;
            _reactRouter.browserHistory.push(obj.link);
          }
        };
        if (menuItem) {
          return _react2.default.createElement(
            _reactBootstrap.MenuItem,
            props,
            obj.text
          );
        } else {
          return _react2.default.createElement(
            _reactBootstrap.NavItem,
            props,
            obj.text
          );
        }
      } else if (obj.hasOwnProperty('href')) {
        var _props = {
          key: obj.href,
          href: obj.href
        };
        if (menuItem) {
          return _react2.default.createElement(
            _reactBootstrap.MenuItem,
            _props,
            obj.text
          );
        } else {
          return _react2.default.createElement(
            _reactBootstrap.NavItem,
            _props,
            obj.text
          );
        }
      } else if (obj.hasOwnProperty('type')) {
        switch (obj.type) {
          case 'header':
            return _react2.default.createElement(
              _reactBootstrap.MenuItem,
              { key: 'header-' + obj.text, header: true },
              obj.text
            );
          case 'separator':
            return _react2.default.createElement(_reactBootstrap.MenuItem, { key: obj.key, divider: true });
          default:
            return;
        }
      } else if (obj.hasOwnProperty('children')) {
        var active = obj.children.map(function (c) {
          return c.link === pathname;
        }).reduce(function (l, r) {
          return l || r;
        }, false);
        var key = 'parent-' + obj.text;
        return _react2.default.createElement(
          _reactBootstrap.NavDropdown,
          { active: active, key: key, id: key, title: obj.text },
          obj.children.map(function (v) {
            return _this2.renderLayout(v, true);
          })
        );
      } else return null;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var layout = this.props.layout;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          _reactBootstrap.Navbar,
          null,
          _react2.default.createElement(
            _reactBootstrap.Navbar.Header,
            null,
            _react2.default.createElement(
              _reactBootstrap.Navbar.Brand,
              null,
              _react2.default.createElement(
                _reactRouter.Link,
                { to: '/', className: 'navbar-brand' },
                _react2.default.createElement('img', { src: '', className: 'brand-img' })
              )
            ),
            _react2.default.createElement(_reactBootstrap.Navbar.Toggle, null)
          ),
          _react2.default.createElement(
            _reactBootstrap.Navbar.Collapse,
            null,
            _react2.default.createElement(
              _reactBootstrap.Nav,
              null,
              layout.map(function (v) {
                return _this3.renderLayout(v);
              })
            )
          )
        ),
        this.props.children
      );
    }
  }]);

  return Navigation;
}(_react.Component);

Navigation.propTypes = {
  layout: _react2.default.PropTypes.array.isRequired
};
exports.default = Navigation;